﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.Runtime.InteropServices;
using ASStoredProcs;

namespace ClearFSCache
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                Console.WriteLine("Clearing active/standby system file cache ...");
                FileSystemCache.ClearAllCaches();
                Console.WriteLine("Successfully cleared active/standby system file cache ...");
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }

            Process[] plist = Process.GetProcesses();
            try
            {
                foreach (Process p in plist)
                {
                    if (p.Id == Process.GetCurrentProcess().Id)
                    {
                        Console.WriteLine("Ignoring current process #" + p.Id + " (" + p.ProcessName + ")");
                    }
                    else
                    {
                        Console.WriteLine("Emptying working set for process #" + p.Id + " (" + p.ProcessName + ")");
                        EmptyWorkingSet(p.Handle.ToInt64());
                        Console.WriteLine("Successfully emptied working set for process #" + p.Id + " (" + p.ProcessName + ")");
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error: " + ex.Message);
            }
        }

        [DllImport("psapi")]
        public static extern bool EmptyWorkingSet(long hProcess);
    }
}
